// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GIOMM_TIMEZONEMONITOR_H
#define _GIOMM_TIMEZONEMONITOR_H


#include <glibmm.h>

/* Copyright (C) 2011 The giomm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GTimeZoneMonitor GTimeZoneMonitor;
typedef struct _GTimeZoneMonitorClass GTimeZoneMonitorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gio
{ class TimeZoneMonitor_Class; } // namespace Gio
namespace Gio
{

/** TimeZoneMonitor - Monitor the local timezone.
 * TimeZoneMonitor is a utility class to monitor the local timezone for changes
 * (ie: in response to the user manually changing the timezone to that of a
 * different locale).
 *
 * You must use this class in order for your program to notice changes to the
 * local timezone. It works by monitoring the /etc/localtime file. When the
 * timezone is found to have changed, the "changed" signal is emitted on the
 * TimeZoneMonitor.
 *
 * See the C API docs for more information.
 *
 * @newin{2,30}
 */

class TimeZoneMonitor : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TimeZoneMonitor CppObjectType;
  typedef TimeZoneMonitor_Class CppClassType;
  typedef GTimeZoneMonitor BaseObjectType;
  typedef GTimeZoneMonitorClass BaseClassType;

private:  friend class TimeZoneMonitor_Class;
  static CppClassType timezonemonitor_class_;

private:
  // noncopyable
  TimeZoneMonitor(const TimeZoneMonitor&);
  TimeZoneMonitor& operator=(const TimeZoneMonitor&);

protected:
  explicit TimeZoneMonitor(const Glib::ConstructParams& construct_params);
  explicit TimeZoneMonitor(GTimeZoneMonitor* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TimeZoneMonitor();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GTimeZoneMonitor*       gobj()       { return reinterpret_cast<GTimeZoneMonitor*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GTimeZoneMonitor* gobj() const { return reinterpret_cast<GTimeZoneMonitor*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GTimeZoneMonitor* gobj_copy();

private:


public:
  
  static Glib::RefPtr<TimeZoneMonitor> get();

  
  /**
   * @par Prototype:
   * <tt>void on_my_%changed()</tt>
   */

  Glib::SignalProxy0< void > signal_changed();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gio


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gio::TimeZoneMonitor
   */
  Glib::RefPtr<Gio::TimeZoneMonitor> wrap(GTimeZoneMonitor* object, bool take_copy = false);
}


#endif /* _GIOMM_TIMEZONEMONITOR_H */

